/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : KeypadColumnsIn.H
**     Project   : DC17
**     Processor : MC56F8006_32_LQFP
**     Beantype  : BitsIO
**     Version   : Bean 02.098, Driver 01.19, CPU db: 3.00.169
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 7/5/2010, 2:14 PM
**     Abstract  :
**         This bean "BitsIO" implements a multi-bit input/output.
**         It uses selected pins of one 1-bit to 8-bit port.
**         Note: This bean is set to work in Input direction only.
**     Settings  :
**         Port name                   : GPIOB
**
**         Bit mask of the port        : 15
**         Number of bits/pins         : 4
**         Single bit numbers          : 0 to 3
**         Values range                : 0 to 15
**
**         Initial direction           : Input (direction cannot be changed)
**         Initial output value        : 0 = 000H
**         Initial pull option         : up
**
**         Port data register          : GPIO_B_DR [61857]
**         Port control register       : GPIO_B_DDR [61858]
**         Port function register      : GPIO_B_PER [61859]
**
**             ----------------------------------------------------
**                   Bit     |   Pin   |   Name
**             ----------------------------------------------------
**                    0      |    21   |   GPIOB0_ANB13_PWM3_SCLK_SCL_T1
**                    1      |    2    |   GPIOB1_ANA12_SSB_SDA_CMP2_P3
**                    2      |    17   |   GPIOB2_ANA2_ANB2_MISO_TIN2_CMP0_OUT
**                    3      |    16   |   GPIOB3_ANA3_ANB3_PWM5_MOSI_TIN3_CMP1_OUT
**             ----------------------------------------------------
**
**         Optimization for            : speed
**     Contents  :
**         GetDir - bool KeypadColumnsIn_GetDir(void);
**         GetVal - byte KeypadColumnsIn_GetVal(void);
**         GetBit - bool KeypadColumnsIn_GetBit(byte Bit);
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

#ifndef __KeypadColumnsIn_H
#define __KeypadColumnsIn_H

/* MODULE KeypadColumnsIn. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include "Cpu.h"

#define KeypadColumnsIn_PIN_MASK ((byte)15) /* Pin mask */


/*
** ===================================================================
**     Method      :  KeypadColumnsIn_GetVal (bean BitsIO)
**
**     Description :
**         This method returns an input value.
**           a) direction = Input  : reads the input value from the
**                                   pins and returns it
**           b) direction = Output : returns the last written value
**         Note: This bean is set to work in Input direction only.
**     Parameters  : None
**     Returns     :
**         ---        - Input value (0 to 15)
** ===================================================================
*/
#define KeypadColumnsIn_GetVal() ((byte)(getRegBits(GPIO_B_DR,KeypadColumnsIn_PIN_MASK)))
/*
** ===================================================================
**     Method      :  KeypadColumnsIn_GetBit (bean BitsIO)
**
**     Description :
**         This method returns the specified bit of the input value.
**           a) direction = Input  : reads the input value from pins
**                                   and returns the specified bit
**           b) direction = Output : returns the specified bit
**                                   of the last written value
**         Note: This bean is set to work in Input direction only.
**     Parameters  :
**         NAME       - DESCRIPTION
**         Bit        - Number of the bit to read (0 to 3)
**     Returns     :
**         ---        - Value of the specified bit (FALSE or TRUE)
**                      FALSE = "0" or "Low", TRUE = "1" or "High"
** ===================================================================
*/
bool KeypadColumnsIn_GetBit(byte Bit);

/*
** ===================================================================
**     Method      :  KeypadColumnsIn_GetDir (bean BitsIO)
**
**     Description :
**         This method returns direction of the bean.
**     Parameters  : None
**     Returns     :
**         ---        - Direction of the bean (always FALSE, Input only)
**                      FALSE = Input, TRUE = Output
** ===================================================================
*/
#define KeypadColumnsIn_GetDir() ((bool)(getRegBits(GPIO_B_DDR,KeypadColumnsIn_PIN_MASK)))

/* END KeypadColumnsIn. */

#endif /* __KeypadColumnsIn_H*/
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.99 [04.17]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
