/** ###################################################################
**     Filename  : Redbox.H
**     Project   : DDSTest
**     Processor : MC56F8006_48_LQFP
**     Version   : Driver 01.13
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 7/24/2009, 4:32 PM
**     Abstract  :
**         Main module.
**         This module contains user's application code.
**     Settings  :
**     Contents  :
**         No public methods
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/
/* MODULE Redbox */
#ifndef __REDBOX_H
#define __REDBOX_H

/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include "ToneGenerate.h"

typedef enum
{
	REDBOX_WAITING_FOR_VALID_KEYPRESS,
	REDBOX_PLAYING_TONE,
	REDBOX_PLAYING_PAUSE,
	REDBOX_WAITING_FOR_KEY_RELEASE
} RedboxFSMState_t;


void RunRedboxFSM(Keypress_t Keycode, UWord16 SampleRate);

/* END Redbox */
#endif /* __REDBOX_H*/
