/** ###################################################################
**     Filename  : ToneGenerate.H
**     Project   : DDSTest
**     Processor : MC56F8006_48_LQFP
**     Version   : Driver 01.13
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 7/24/2009, 4:32 PM
**     Abstract  :
**         Main module.
**         This module contains user's application code.
**     Settings  :
**     Contents  :
**         No public methods
**
**     (c) Copyright UNIS, a.s. 1997-2008
**     UNIS, a.s.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/
/* MODULE ToneGenerate */
#ifndef __TONEGENERATE_H
#define __TONEGENERATE_H


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "AudioOutputPWM.h"
/* Including shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* enumerated type used to select tone pair based on key pressed */
typedef enum
{
	KEY_PRESS_INVALID = 0,
	KEY_PRESS_1,
	KEY_PRESS_2,
	KEY_PRESS_3,
	KEY_PRESS_4,
	KEY_PRESS_5,
	KEY_PRESS_6,
	KEY_PRESS_7,
	KEY_PRESS_8,
	KEY_PRESS_9,
	KEY_PRESS_0,
	KEY_PRESS_STAR,
	KEY_PRESS_POUND,
	KEY_PRESS_A,
	KEY_PRESS_B,
	KEY_PRESS_C,
	KEY_PRESS_D,
	MAX_KEY_PRESS_VALUES	
}	Keypress_t;

typedef enum
{
	KEYTONE_MODE_MF,
	KEYTONE_MODE_DTMF,
	KEYTONE_MODE_REDBOX
}	KeytoneMode_t;


void PlayTone(Keypress_t Keycode, KeytoneMode_t Mode, UWord16 SampleRate);

/* END ToneGenerate */
#endif /* __TONEGENERATE_H*/
